diff --git a/doc/guides/nics/features.rst b/doc/guides/nics/features.rst
index d35751d5b5a7..676df5a5e3c8 100644
--- a/doc/guides/nics/features.rst
+++ b/doc/guides/nics/features.rst
@@ -158,18 +158,6 @@ Supports updating port MTU.
 * **[related]    API**: ``rte_eth_dev_set_mtu()``, ``rte_eth_dev_get_mtu()``.
 
 
-.. _nic_features_jumbo_frame:
-
-Jumbo frame
------------
-
-Supports Rx jumbo frames.
-
-* **[uses]    rte_eth_rxconf,rte_eth_rxmode**: ``dev_conf.rxmode.mtu``.
-* **[related] rte_eth_dev_info**: ``max_rx_pktlen``.
-* **[related] API**: ``rte_eth_dev_set_mtu()``.
-
-
 .. _nic_features_scattered_rx:
 
 Scattered Rx
diff --git a/doc/guides/nics/features/ark.ini b/doc/guides/nics/features/ark.ini
index 5519984e3926..87b4209165d7 100644
--- a/doc/guides/nics/features/ark.ini
+++ b/doc/guides/nics/features/ark.ini
@@ -6,7 +6,6 @@
 [Features]
 Speed capabilities   = Y
 Queue start/stop     = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Basic stats          = Y
 Stats per queue      = Y
diff --git a/doc/guides/nics/features/atlantic.ini b/doc/guides/nics/features/atlantic.ini
index d2ec33b21742..ef4155027c72 100644
--- a/doc/guides/nics/features/atlantic.ini
+++ b/doc/guides/nics/features/atlantic.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
 Unicast MAC filter   = Y
diff --git a/doc/guides/nics/features/avp.ini b/doc/guides/nics/features/avp.ini
index 9352c989feaa..f2f115ba61e8 100644
--- a/doc/guides/nics/features/avp.ini
+++ b/doc/guides/nics/features/avp.ini
@@ -5,7 +5,6 @@
 ;
 [Features]
 Link status          = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Unicast MAC filter   = Y
diff --git a/doc/guides/nics/features/axgbe.ini b/doc/guides/nics/features/axgbe.ini
index e11f440d7350..821bb682d433 100644
--- a/doc/guides/nics/features/axgbe.ini
+++ b/doc/guides/nics/features/axgbe.ini
@@ -6,7 +6,6 @@
 [Features]
 Speed capabilities   = Y
 Link status          = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
diff --git a/doc/guides/nics/features/bnxt.ini b/doc/guides/nics/features/bnxt.ini
index c0e8ecb82be5..93aa98aedef9 100644
--- a/doc/guides/nics/features/bnxt.ini
+++ b/doc/guides/nics/features/bnxt.ini
@@ -12,7 +12,6 @@ Fast mbuf free       = Y
 Queue start/stop     = Y
 Burst mode info      = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/cnxk.ini b/doc/guides/nics/features/cnxk.ini
index 03af0da30297..1623a1803e7c 100644
--- a/doc/guides/nics/features/cnxk.ini
+++ b/doc/guides/nics/features/cnxk.ini
@@ -29,7 +29,6 @@ RSS reta update      = Y
 Inner RSS            = Y
 Inline protocol      = Y
 Flow control         = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 L3 checksum offload  = Y
 L4 checksum offload  = Y
diff --git a/doc/guides/nics/features/cnxk_vec.ini b/doc/guides/nics/features/cnxk_vec.ini
index 12ca0a587ca7..4b7c2bce4dd6 100644
--- a/doc/guides/nics/features/cnxk_vec.ini
+++ b/doc/guides/nics/features/cnxk_vec.ini
@@ -28,7 +28,6 @@ RSS reta update      = Y
 Inner RSS            = Y
 Inline protocol      = Y
 Flow control         = Y
-Jumbo frame          = Y
 L3 checksum offload  = Y
 L4 checksum offload  = Y
 Inner L3 checksum    = Y
diff --git a/doc/guides/nics/features/cnxk_vf.ini b/doc/guides/nics/features/cnxk_vf.ini
index f3d9f23f1749..0523be434d2b 100644
--- a/doc/guides/nics/features/cnxk_vf.ini
+++ b/doc/guides/nics/features/cnxk_vf.ini
@@ -23,7 +23,6 @@ RSS key update       = Y
 RSS reta update      = Y
 Inner RSS            = Y
 Inline protocol      = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 L3 checksum offload  = Y
 L4 checksum offload  = Y
diff --git a/doc/guides/nics/features/cxgbe.ini b/doc/guides/nics/features/cxgbe.ini
index f41fc1482527..f674803ec47f 100644
--- a/doc/guides/nics/features/cxgbe.ini
+++ b/doc/guides/nics/features/cxgbe.ini
@@ -8,7 +8,6 @@ Speed capabilities   = Y
 Link status          = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/cxgbevf.ini b/doc/guides/nics/features/cxgbevf.ini
index a3174ef39955..a34fddd64e33 100644
--- a/doc/guides/nics/features/cxgbevf.ini
+++ b/doc/guides/nics/features/cxgbevf.ini
@@ -8,7 +8,6 @@ Speed capabilities   = Y
 Link status          = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/default.ini b/doc/guides/nics/features/default.ini
index 082c7e85db15..21178e163253 100644
--- a/doc/guides/nics/features/default.ini
+++ b/doc/guides/nics/features/default.ini
@@ -23,7 +23,6 @@ Shared Rx queue      =
 Burst mode info      =
 Power mgmt address monitor =
 MTU update           =
-Jumbo frame          =
 Scattered Rx         =
 LRO                  =
 TSO                  =
diff --git a/doc/guides/nics/features/dpaa.ini b/doc/guides/nics/features/dpaa.ini
index e0ed3e86832b..a382c7160cbc 100644
--- a/doc/guides/nics/features/dpaa.ini
+++ b/doc/guides/nics/features/dpaa.ini
@@ -8,7 +8,6 @@ Speed capabilities   = Y
 Link status          = Y
 Link status event    = Y
 Burst mode info      = Y
-Jumbo frame          = Y
 MTU update           = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/dpaa2.ini b/doc/guides/nics/features/dpaa2.ini
index 00af720cab47..4c06841a8798 100644
--- a/doc/guides/nics/features/dpaa2.ini
+++ b/doc/guides/nics/features/dpaa2.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Burst mode info      = Y
 Queue start/stop     = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 MTU update           = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/e1000.ini b/doc/guides/nics/features/e1000.ini
index b33f5a86e2e9..e4bdef6da90e 100644
--- a/doc/guides/nics/features/e1000.ini
+++ b/doc/guides/nics/features/e1000.ini
@@ -10,7 +10,6 @@ Link status event    = Y
 Rx interrupt         = Y
 Free Tx mbuf on demand = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
diff --git a/doc/guides/nics/features/ena.ini b/doc/guides/nics/features/ena.ini
index b971243ff05a..4db1db11f486 100644
--- a/doc/guides/nics/features/ena.ini
+++ b/doc/guides/nics/features/ena.ini
@@ -8,7 +8,6 @@ Link status          = Y
 Link status event    = Y
 Rx interrupt         = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 RSS hash             = Y
diff --git a/doc/guides/nics/features/enetc.ini b/doc/guides/nics/features/enetc.ini
index 2087bb973b8c..c197e280bf6c 100644
--- a/doc/guides/nics/features/enetc.ini
+++ b/doc/guides/nics/features/enetc.ini
@@ -10,7 +10,6 @@ Basic stats          = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
 MTU update           = Y
-Jumbo frame          = Y
 Queue start/stop     = Y
 CRC offload          = Y
 L3 checksum offload  = P
diff --git a/doc/guides/nics/features/enic.ini b/doc/guides/nics/features/enic.ini
index ecff6c5f26f0..30643361625c 100644
--- a/doc/guides/nics/features/enic.ini
+++ b/doc/guides/nics/features/enic.ini
@@ -11,7 +11,6 @@ Rx interrupt         = Y
 Queue start/stop     = Y
 Burst mode info      = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/failsafe.ini b/doc/guides/nics/features/failsafe.ini
index 8a2b92fc9cf3..00dcd0e03bc7 100644
--- a/doc/guides/nics/features/failsafe.ini
+++ b/doc/guides/nics/features/failsafe.ini
@@ -12,7 +12,6 @@ Queue start/stop     = Y
 Runtime Rx queue setup = Y
 Runtime Tx queue setup = Y
 MTU update           = Y
-Jumbo frame          = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
 Unicast MAC filter   = Y
diff --git a/doc/guides/nics/features/fm10k.ini b/doc/guides/nics/features/fm10k.ini
index 1faa7ce59c2b..e2701d2d473f 100644
--- a/doc/guides/nics/features/fm10k.ini
+++ b/doc/guides/nics/features/fm10k.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Rx interrupt         = Y
 Queue start/stop     = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/fm10k_vf.ini b/doc/guides/nics/features/fm10k_vf.ini
index c5f3161a2e90..ba8bc861b1bf 100644
--- a/doc/guides/nics/features/fm10k_vf.ini
+++ b/doc/guides/nics/features/fm10k_vf.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Rx interrupt         = Y
 Queue start/stop     = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 RSS hash             = Y
diff --git a/doc/guides/nics/features/hinic.ini b/doc/guides/nics/features/hinic.ini
index 4ea736870465..9f6f0ebf3af3 100644
--- a/doc/guides/nics/features/hinic.ini
+++ b/doc/guides/nics/features/hinic.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 LRO                  = Y
diff --git a/doc/guides/nics/features/hns3.ini b/doc/guides/nics/features/hns3.ini
index cf8d53d0d68f..c3464c839649 100644
--- a/doc/guides/nics/features/hns3.ini
+++ b/doc/guides/nics/features/hns3.ini
@@ -14,7 +14,6 @@ Runtime Tx queue setup = Y
 Burst mode info      = Y
 Free Tx mbuf on demand = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 LRO                  = Y
diff --git a/doc/guides/nics/features/hns3_vf.ini b/doc/guides/nics/features/hns3_vf.ini
index 7da994c2dc83..8ef771d04a9d 100644
--- a/doc/guides/nics/features/hns3_vf.ini
+++ b/doc/guides/nics/features/hns3_vf.ini
@@ -13,7 +13,6 @@ Runtime Tx queue setup = Y
 Burst mode info      = Y
 Free Tx mbuf on demand = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 LRO                  = Y
diff --git a/doc/guides/nics/features/i40e.ini b/doc/guides/nics/features/i40e.ini
index e3a575f89132..dd18fec21768 100644
--- a/doc/guides/nics/features/i40e.ini
+++ b/doc/guides/nics/features/i40e.ini
@@ -14,7 +14,6 @@ Runtime Rx queue setup = Y
 Runtime Tx queue setup = Y
 Burst mode info      = Y
 Power mgmt address monitor = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/iavf.ini b/doc/guides/nics/features/iavf.ini
index a916275b885d..dd3519e1e2ec 100644
--- a/doc/guides/nics/features/iavf.ini
+++ b/doc/guides/nics/features/iavf.ini
@@ -10,7 +10,6 @@ Rx interrupt         = Y
 Queue start/stop     = Y
 Power mgmt address monitor = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/ice.ini b/doc/guides/nics/features/ice.ini
index 8e43ade1aac9..9fd52fdd2200 100644
--- a/doc/guides/nics/features/ice.ini
+++ b/doc/guides/nics/features/ice.ini
@@ -13,7 +13,6 @@ Queue start/stop     = Y
 Burst mode info      = Y
 Power mgmt address monitor = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/ice_dcf.ini b/doc/guides/nics/features/ice_dcf.ini
index ae79b6a51529..4d6fb6d8491c 100644
--- a/doc/guides/nics/features/ice_dcf.ini
+++ b/doc/guides/nics/features/ice_dcf.ini
@@ -5,7 +5,6 @@
 ;
 [Features]
 Queue start/stop     = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 RSS hash             = P
 CRC offload          = Y
diff --git a/doc/guides/nics/features/igb.ini b/doc/guides/nics/features/igb.ini
index f4f6e9a4cb2f..7b4af6f86c21 100644
--- a/doc/guides/nics/features/igb.ini
+++ b/doc/guides/nics/features/igb.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Rx interrupt         = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/igc.ini b/doc/guides/nics/features/igc.ini
index f810c2df4e76..f2c6fa28ad8f 100644
--- a/doc/guides/nics/features/igc.ini
+++ b/doc/guides/nics/features/igc.ini
@@ -12,7 +12,6 @@ Packet type parsing  = Y
 Rx descriptor status = Y
 Tx descriptor status = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/ionic.ini b/doc/guides/nics/features/ionic.ini
index 330c71dd208c..5bd18e39e95f 100644
--- a/doc/guides/nics/features/ionic.ini
+++ b/doc/guides/nics/features/ionic.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/ipn3ke.ini b/doc/guides/nics/features/ipn3ke.ini
index 2bf92fd7a1e7..defc39f5250f 100644
--- a/doc/guides/nics/features/ipn3ke.ini
+++ b/doc/guides/nics/features/ipn3ke.ini
@@ -11,7 +11,6 @@ Rx interrupt         = Y
 Queue start/stop     = Y
 Runtime Rx queue setup = Y
 Runtime Tx queue setup = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/ixgbe.ini b/doc/guides/nics/features/ixgbe.ini
index 73cf63866420..c5333d11426a 100644
--- a/doc/guides/nics/features/ixgbe.ini
+++ b/doc/guides/nics/features/ixgbe.ini
@@ -11,7 +11,6 @@ Rx interrupt         = Y
 Queue start/stop     = Y
 Power mgmt address monitor = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/ixgbe_vf.ini b/doc/guides/nics/features/ixgbe_vf.ini
index 9241aebd2157..e14325045c7e 100644
--- a/doc/guides/nics/features/ixgbe_vf.ini
+++ b/doc/guides/nics/features/ixgbe_vf.ini
@@ -8,7 +8,6 @@ Link status          = Y
 Rx interrupt         = Y
 Power mgmt address monitor = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/liquidio.ini b/doc/guides/nics/features/liquidio.ini
index 100c7213e0ec..a8bde282e03b 100644
--- a/doc/guides/nics/features/liquidio.ini
+++ b/doc/guides/nics/features/liquidio.ini
@@ -8,7 +8,6 @@ Speed capabilities   = Y
 Link status          = Y
 Link status event    = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
diff --git a/doc/guides/nics/features/memif.ini b/doc/guides/nics/features/memif.ini
index 807d9ecdce08..0368b7a02c19 100644
--- a/doc/guides/nics/features/memif.ini
+++ b/doc/guides/nics/features/memif.ini
@@ -6,7 +6,6 @@
 [Features]
 Link status          = Y
 Basic stats          = Y
-Jumbo frame          = Y
 ARMv8                = Y
 Power8               = Y
 x86-32               = Y
diff --git a/doc/guides/nics/features/mlx4.ini b/doc/guides/nics/features/mlx4.ini
index c394dfcefe85..82f6f0bc0bb3 100644
--- a/doc/guides/nics/features/mlx4.ini
+++ b/doc/guides/nics/features/mlx4.ini
@@ -11,7 +11,6 @@ Removal event        = Y
 Rx interrupt         = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/mlx5.ini b/doc/guides/nics/features/mlx5.ini
index 0e72021d4a06..403f58cd7e2c 100644
--- a/doc/guides/nics/features/mlx5.ini
+++ b/doc/guides/nics/features/mlx5.ini
@@ -14,7 +14,6 @@ Queue start/stop     = Y
 Burst mode info      = Y
 Power mgmt address monitor = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/mvneta.ini b/doc/guides/nics/features/mvneta.ini
index 701eb03d8017..446987e1b54a 100644
--- a/doc/guides/nics/features/mvneta.ini
+++ b/doc/guides/nics/features/mvneta.ini
@@ -7,7 +7,6 @@
 Speed capabilities   = Y
 Link status          = Y
 MTU update           = Y
-Jumbo frame          = Y
 Promiscuous mode     = Y
 Unicast MAC filter   = Y
 CRC offload          = Y
diff --git a/doc/guides/nics/features/mvpp2.ini b/doc/guides/nics/features/mvpp2.ini
index 2ce0ca817aea..1bcf74875e8d 100644
--- a/doc/guides/nics/features/mvpp2.ini
+++ b/doc/guides/nics/features/mvpp2.ini
@@ -7,7 +7,6 @@
 Speed capabilities   = Y
 Link status          = Y
 MTU update           = Y
-Jumbo frame          = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
 Unicast MAC filter   = Y
diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index fee9dae87801..f7a0362eb279 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -10,7 +10,6 @@ Link status event    = Y
 Rx interrupt         = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Promiscuous mode     = Y
 TSO                  = Y
 RSS hash             = Y
diff --git a/doc/guides/nics/features/octeontx.ini b/doc/guides/nics/features/octeontx.ini
index d6fd61009064..78fa7c719a88 100644
--- a/doc/guides/nics/features/octeontx.ini
+++ b/doc/guides/nics/features/octeontx.ini
@@ -10,7 +10,6 @@ Link status event    = Y
 Lock-free Tx queue   = Y
 Queue start/stop     = P
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Unicast MAC filter   = Y
diff --git a/doc/guides/nics/features/octeontx2.ini b/doc/guides/nics/features/octeontx2.ini
index e0277988d4b4..bf0c2890f2e6 100644
--- a/doc/guides/nics/features/octeontx2.ini
+++ b/doc/guides/nics/features/octeontx2.ini
@@ -31,7 +31,6 @@ Inline protocol      = Y
 VLAN filter          = Y
 Flow control         = Y
 Rate limitation      = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 VLAN offload         = Y
 QinQ offload         = Y
diff --git a/doc/guides/nics/features/octeontx2_vec.ini b/doc/guides/nics/features/octeontx2_vec.ini
index 376a1d6cc1ad..c405db7cf91a 100644
--- a/doc/guides/nics/features/octeontx2_vec.ini
+++ b/doc/guides/nics/features/octeontx2_vec.ini
@@ -28,7 +28,6 @@ Inner RSS            = Y
 VLAN filter          = Y
 Flow control         = Y
 Rate limitation      = Y
-Jumbo frame          = Y
 VLAN offload         = Y
 QinQ offload         = Y
 L3 checksum offload  = Y
diff --git a/doc/guides/nics/features/octeontx2_vf.ini b/doc/guides/nics/features/octeontx2_vf.ini
index 8141aadf8509..5ac7a49a5c7e 100644
--- a/doc/guides/nics/features/octeontx2_vf.ini
+++ b/doc/guides/nics/features/octeontx2_vf.ini
@@ -24,7 +24,6 @@ Inner RSS            = Y
 Inline protocol      = Y
 VLAN filter          = Y
 Rate limitation      = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 VLAN offload         = Y
 QinQ offload         = Y
diff --git a/doc/guides/nics/features/pcap.ini b/doc/guides/nics/features/pcap.ini
index 28e648807413..7fd22b190e79 100644
--- a/doc/guides/nics/features/pcap.ini
+++ b/doc/guides/nics/features/pcap.ini
@@ -4,7 +4,6 @@
 ; Refer to default.ini for the full list of available PMD features.
 ;
 [Features]
-Jumbo frame          = Y
 Basic stats          = Y
 Multiprocess aware   = Y
 ARMv7                = Y
diff --git a/doc/guides/nics/features/qede.ini b/doc/guides/nics/features/qede.ini
index e65d5d076ed9..e6fe2d4aeb83 100644
--- a/doc/guides/nics/features/qede.ini
+++ b/doc/guides/nics/features/qede.ini
@@ -7,7 +7,6 @@
 Speed capabilities   = Y
 Link status          = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/qede_vf.ini b/doc/guides/nics/features/qede_vf.ini
index e71a3e5ac462..6cf146341ff6 100644
--- a/doc/guides/nics/features/qede_vf.ini
+++ b/doc/guides/nics/features/qede_vf.ini
@@ -7,7 +7,6 @@
 Speed capabilities   = Y
 Link status          = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
diff --git a/doc/guides/nics/features/sfc.ini b/doc/guides/nics/features/sfc.ini
index c5fadeceb123..7db868e59fa6 100644
--- a/doc/guides/nics/features/sfc.ini
+++ b/doc/guides/nics/features/sfc.ini
@@ -13,7 +13,6 @@ Queue start/stop     = Y
 Runtime Rx queue setup = Y
 Runtime Tx queue setup = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 TSO                  = Y
 Promiscuous mode     = Y
diff --git a/doc/guides/nics/features/thunderx.ini b/doc/guides/nics/features/thunderx.ini
index add542817445..b33bb37c829b 100644
--- a/doc/guides/nics/features/thunderx.ini
+++ b/doc/guides/nics/features/thunderx.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
diff --git a/doc/guides/nics/features/txgbe.ini b/doc/guides/nics/features/txgbe.ini
index 61cb3f6d9fd1..6d0cc8afddb7 100644
--- a/doc/guides/nics/features/txgbe.ini
+++ b/doc/guides/nics/features/txgbe.ini
@@ -10,7 +10,6 @@ Link status event    = Y
 Rx interrupt         = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/txgbe_vf.ini b/doc/guides/nics/features/txgbe_vf.ini
index 349990cb00be..d071717f094b 100644
--- a/doc/guides/nics/features/txgbe_vf.ini
+++ b/doc/guides/nics/features/txgbe_vf.ini
@@ -9,7 +9,6 @@ Unicast MAC filter   = Y
 Multicast MAC filter = Y
 Rx interrupt         = Y
 MTU update           = Y
-Jumbo frame          = Y
 Scattered Rx         = Y
 LRO                  = Y
 TSO                  = Y
diff --git a/doc/guides/nics/features/vmxnet3.ini b/doc/guides/nics/features/vmxnet3.ini
index c74d7d59634b..971695fc4ad5 100644
--- a/doc/guides/nics/features/vmxnet3.ini
+++ b/doc/guides/nics/features/vmxnet3.ini
@@ -9,7 +9,6 @@ Link status          = Y
 Link status event    = Y
 Queue start/stop     = Y
 MTU update           = Y
-Jumbo frame          = Y
 LRO                  = Y
 TSO                  = Y
 Promiscuous mode     = Y